Description

Supportanfrage

wir haben hier eine Anfrage bekommen die ich gerne an euch weitergeben méchte:

"Wenn ein ADTF System nicht alle Abh&ngigkeiten (in der richtigen Reihenfolge und Runlevel) bereit stellt, bekommt der Nutzer
derzeit oft keine Informationen Gber die Ursache.

Beispiel: Der ADTF2 SessionManager benétigt den Namespace Service. Fehlt der Namespace Service, gibt es nur einen wenig
hilfreichen Fehlercode.

Idee: Erweiterung von ucom::IRuntimeHook, sodass Aufrufe von ucom::IRuntime::GetObject() nachvollzogen werden kénnen. Zu
beantwortende Frage:

e Welche Instanz ruft GetObject mit welchen Parametern auf (sollte die anfragende Instanz nicht ermittelt werden kénnen, waren
die Parameter allein auch schon hilfreich)

Diese Anforderung ist aus meiner Sicht sowohl fir ADTF2 als auch ADTF3 wichtig."

Viele Grif3e,
Anja

Lésung

ACORE-10428 fir bessere Fehlermeldung erdffnet.

Zum damit verbundenen Absturz in der Display Toolbox:

Das ist ein bekanntes Problem und wird in der Display Toolbox 3.5.0 geldst sein:

* siehe https://support.digitalwerk.net/projects/download-center/wiki/KnownProblems#ADTF-Display-Toolbox-Known-Problems

Die Services werden nicht im richtigen Runlevel geladen und haben auch keine Abhangigkeit geladen.
Workaround aktuell ist die Plugin Desciptions entsprechend handisch zu fixen.
<required_interfaces>
<interface_description>
<iid>signal_registry.flash.services.adtf.iid</iid>
</interface_description>
<interface_description>
<iid>signal_registry.ant.services.adtf.iid</iid>

</interface_description>

</required_interfaces>
<runlevel>session</runlevel>

Alternativ kann man nattirlich auch alles pro Anwendungsfall im System Editor machen, die Anpassung der Plugin Descriptions der
drei Ul Services ist aber sicherlich die nachhaltigere "Lésung" bis zur Display TB 3.5.0.

History

#1 - 2020-02-26 13:07 - hidden

- Project changed from Public Support to 7

- Status changed from New to Customer Feedback Required
- Topic set to ADTF::Common

- Customer set to ELEKTROBIT

- Department set to SUPPORT

Hallo Anja,

wie du ja sicher weif3t ist das Dependency Handling eines der Features in ADTF 3.x.

Jedes Plugin bzw. Komponente spezifiziert seine Abhangigkeiten (REQUIRED_INTERFACES), diese werden in die Plugin Description auch
exportiert und vom CE entsprechend ausgewertet.

Dadurch wird sichergestellt, dass Laufzeitabhangigkeiten in der korrekten Reihenfolge mit dem geforderten Runlevel im System File gesetzt werden,
hier muss der Endanwender keine Hand mehr anlegen.

Im ADTF 2.x sind uns hier bekanntlich die Hande gebunden.

#2 - 2020-02-28 09:00 - hidden
- File image001.png added

Hallo Florian,

die Dependency Resolution im Configurationseditor ist zwar gut und auch schon besser geworden, 16st aber nicht alle Probleme, z.B. werden die Run
Level nicht berlicksichtigt. Also selbst wenn das benutzt wurde, kann es zu Fehlern kommen. Dann gibt es natirlich noch Fehler der Benutzer und
Entwickler, die auch zu sinnvollen Fehlermeldungen fuhren sollten.

Die Fehlermeldungen wegen nicht gefunden Interfaces sind aber sehr unspezifisch. Man erfahrt lediglich, dass der GetObject Aufruf fehl schlug.

image001.png
Sieht so aus, also ob im rpc_object_regstry.cpp die entsprechenden Exceptions abgefangen werden.
Waére es moglich:
Das Handling mit den REQUIRED_INTERFACES so ausbauen, dass auch Runtime-Checks mit guten Fehlermeldungen beim laden/initialisieren des
Moduls durchgefihrt werden. Evtl. zu strikt, da man so nicht die Prifung abhéngig von dem Entsprechenden Initialisierungsschritt macht.

Deshalb alternativ: Die Fehlermeldung mit der angefragten iid bzw. cid erganzen.

Dann ist da noch das Problem hierbei ist, dass das kein Automatismus ist.

Der Programmierer kann den Eintrag fir REQUIRED_INTERFACES versehentlich weglassen und es dennoch benutzen.
In dem Fall fallt die Fehlersuche schwer, wenn man den Source Code nicht hat.

GriBe,
Anja

#3 - 2020-03-02 12:20 - hidden

Hallo Anja,

die Dependency Resolution im Configurationseditor ist zwar gut und auch schon besser geworden, 16st aber nicht alle Probleme, z.B. werden die
Run Level nicht berlcksichtigt.
Also selbst wenn das benutzt wurde, kann es zu Fehlern kommen.

Das stimmt nicht, was meinst du damit ?

In jedem Service wird ein Default Runlevel definiert, das gibt der Entwickler vor und so landet es auch in der Plugin Description.
Siehe https://support.digitalwerk.net/adtf/v3/guides/sdk_generate_plugin_description.html

Wer das andert, bricht den Vertrag und muss sich dessen bewusst sein. Oder verstehe ich dich falsch ?

Was wir noch anbieten wollen:
e Einen Hinweis und Reset Funktion, wenn das default runlevel geéndert wird (ACORE-10426)

e Dass der Launcher bzgl. noch mehr checks und Ausgabe (Abhangigkeiten, default Vergleich, etc) zur Laufzeit durchfuhrt beim Start
(ACORE-10425)
Dann gibt es natirlich noch Fehler der Benutzer und Entwickler, die auch zu sinnvollen Fehlermeldungen fuhren sollten.
Die Fehlermeldungen wegen nicht gefunden Interfaces sind aber sehr unspezifisch. Man erfahrt lediglich, dass der GetObject Aufruf fehl schlug.
Sieht so aus, also ob im rpc_object_regstry.cpp die entsprechenden Exceptions abgefangen werden.

Das hat aber imho nichts mit Dependencies zu tun, hier wird versucht sich an ein System zu docken (Control, GUI Control), dass nicht existiert, richtig
?
Also wenn du nur mit Launcher ausfiihrst, hattest du im Log die eigentliche Fehlermeldung davor und diese eben nicht ?
@Martin: Kénnen wir hier besser werden ? Die leere Angabe ist sicherlich nichtssagend...
Waére es moglich:
Das Handling mit den REQUIRED_INTERFACES so ausbauen, dass auch Runtime-Checks mit guten Fehlermeldungen beim laden/initialisieren
des Moduls durchgefihrt werden. Evtl. zu strikt, da man so nicht die Priifung abhéangig von dem Entsprechenden Initialisierungsschritt macht.

Das soll wie gesagt in ACORE-10425 noch tiefer gehen

Deshalb alternativ: Die Fehlermeldung mit der angefragten iid bzw. cid erganzen.

Wie gesagt, ich denke das Problem hier ist dass gar kein ADTF System besteht, das per RPC angesrochen wird

Dann ist da noch das Problem hierbei ist, dass das kein Automatismus ist.
Der Programmierer kann den Eintrag fur REQUIRED_INTERFACES versehentlich weglassen und es dennoch benutzen.
In dem Fall fallt die Fehlersuche schwer, wenn man den Source Code nicht hat.

Das hat man an so vielen Stellen in der Programmierung, das gibt aber C++ ohne Reflection leider nicht her und wir wollen nicht den Code parsen.
Das sind Makros die einfach verwendet werden missen im ADTF Kontext (analog zu Header includes), gilt ja auch fur ADTF_PLUGIN.
Wir haben versucht, dass hier zu dokumentieren:

e https://support.digitalwerk.net/adtf/v3/adtf_html/page_versioned_namespaces.html

#4 - 2020-03-03 10:26 - hidden
- Resolution set to Product Issue Opened

- Product Issue Numbers set to https://www.cip.audi.de/jira/browse/ACORE-10428

Hallo Anja,

ich habe fur aussagekraftigere Fehlermeldungen das Ticket https:/www.cip.audi.de/jira/browse/ACORE-10428 erstellt. Dadurch sollte man jetzt
immer zumindest die ID des gesuchten Interfaces in der Fehlermeldung bekommen (und auch die Object IDs der abgefragten Objekte).

GriBe,

Martin

#5 - 2020-03-04 08:28 - hidden

- Support Level changed from 2nd Level to 3rd Level
Hallo Anja,

Martin wrote:

ich habe fur aussagekraftigere Fehlermeldungen das Ticket https:/www.cip.audi.de/jira/browse/ACORE-10428 erstellt. Dadurch sollte man
jetzt immer zumindest die ID des gesuchten Interfaces in der Fehlermeldung bekommen (und auch die Object IDs der abgefragten
Objekte).

nach Umsetzung von ACORE-10428 sieht die Meldung nun so aus:
ADTF Runtime Exception

Exception occurred while running adtf:

Result code '-20 ' (ERR_NOT_FOUND) - default_streaming_graph.Demo Virtual Clock Input: No object with the reque
sted interface found:

'logging.system.adtf': Object does not implement interface 'reference_clock.giant.streaming.adtf.iid'.
'license_manager.system.adtf': Object does not implement interface 'reference_clock.giant.streaming.adtf.iid’.
'macro_resolver.system.adtf': Object does not implement interface 'reference_clock.giant.streaming.adtf.iid'.
'rpc_object_server_registry.system.adtf': Object does not implement interface 'reference_clock.giant.streaming
.adtf.iid'.

'session_manager.system.adtf': Object does not implement interface 'reference_clock.giant.streaming.adtf.iid"'.
'ADTF Kernel Service': Object does not implement interface 'reference_clock.giant.streaming.adtf.iid'.

[File: c:\dev\acore\source\src\libraries\ucom3\src\runtime.cpp] [Line: 1244] [Func: adtf::ucom::catwo::detail:
:cRuntime: :cRuntimePrivate: :GetObject]

[File: c:\dev\acore\source\src\examples\src\adtf\streaming_services\sources\virtual_clock\demo_virtual_clock.c
ppl [Line: 62] [Func: cDemoVirtualClock::StartStreaming]

[File: c:\dev\acore\source\src\libraries\streaming3\src\streaming_graph.cpp] [Line: 387] [Func: adtf::streamin
g::catwo::cStreamingGraph: :SetStateImpl]

[File: c:\dev\acore\source\src\plugins\adtf_core\session_manager.cpp] [Line: 75] [Func: set_session_streaming_
state]

[File: c:\dev\acore\source\src\plugins\adtf_core\session_manager.cpp] [Line: 169] [Func: cSessionManager: :Runt
imeHook]

Und sollte in diesem Fall Aufschluss geben, dass kein Objekt (Service) geladen ist, der die Version der Reference Clock bereitstellt, welche von
Demo Virtual Clock angefragt wird.

#7 - 2020-03-04 09:08 - hidden

Hallo Florian,
ich kommentiere der Einfachheit halber:
Florian Roth wrote:
Hallo Anja,
die Dependency Resolution im Configurationseditor ist zwar gut und auch schon besser geworden, 16st aber nicht alle Probleme, z.B.

werden die Run Level nicht beriicksichtigt.
Also selbst wenn das benutzt wurde, kann es zu Fehlern kommen.

Das stimmt nicht, was meinst du damit ?

Naturlich kommt die Fehlermeldung von einen gelaunchten System, woher denn sonst. Ein nicht gelaunchtes System kann keine Fehlermeldungen
ausgeben.

Das Beispiel kam aus den Device Toolbox Plugins. Dort wird immerhin eine Exception geschmissen, wenn das required interface nicht gefunden
wurde.

Schlimmer ist es in der Display Toolbox:

Er soll doch mal in eins der ADTF Example-Projekten die Signal Tree View Service hinzufiigen. Da gibt’s nicht mal ne Exception. Lediglich die Info
dass der Service nicht geladen werden konnte und ein Absturz.

Es klappt erst, wenn man der Signal Registry Service im Runlevel 1 |adt.

GriBe,
Anja

#8 - 2020-03-04 09:51 - hidden
Hallo Anja,

irgendwie passt dein Text/Antwort nicht zum zitierten Text...
Ich versuche trotzdem darauf einzugehen:

Nattrlich kommt die Fehlermeldung von einen gelaunchten System, woher denn sonst. Ein nicht gelaunchtes System kann keine
Fehlermeldungen ausgeben.

Ich habe mich falsch ausgedriickt und habe die Fehlermeldung falsch interpretiert, ich kenne eine ahnliche bzgl. RPC in Zusammenhang mit ADTF
(GUI) Control und bitte vielmals um Entschuldigung.

Das sollte sich doch aber im weiteren Ticketverlauf auch mit den Ausfiihrungen von Martin schon korrigiert haben, ebenso mit der Umsetzung von
ACORE-10428 gelést sein, siehe nochmal #10608#note-5.

So ist es nun im master und landet auch schon in der 3.7.

Das Beispiel kam aus den Device Toolbox Plugins. Dort wird immerhin eine Exception geschmissen, wenn das required interface nicht gefunden
wurde.
Sollte nun wie gesagt mit ACORE-10428 aufschlussreicher sein.
Schlimmer ist es in der Display Toolbox:

Er soll doch mal in eins der ADTF Example-Projekten die Signal Tree View Service hinzufiigen. Da gibt’s nicht mal ne Exception. Lediglich die
Info dass der Service nicht geladen werden konnte und ein Absturz.

Es klappt erst, wenn man der Signal Registry Service im Runlevel 1 Iadt.

Das ist ein bekanntes Problem und wird in der Display Toolbox 3.5.0 geldst sein:

® siehe https://support.digitalwerk.net/projects/download-center/wiki/KnownProblems#ADTE-Display-Toolbox-Known-Problems

Die Services werden nicht im richtigen Runlevel geladen und haben auch keine Abhangigkeit geladen.
Workaround aktuell ist die Plugin Desciptions entsprechend handisch zu fixen.
<required_interfaces>
<interface_description>
<iid>signal_registry.flash.services.adtf.iid</iid>
</interface_description>
<interface_description>
<iid>signal_registry.ant.services.adtf.iid</iid>
</interface_description>
</required_interfaces>
<runlevel>session</runlevel>

Alternativ kann man nattrlich auch alles pro Anwendungsfall im System Editor machen, die Anpassung der Plugin Descriptions der drei Ul Services
ist aber sicherlich die nachhaltigere "Lésung" bis zur Display TB 3.5.0.

Allgemein bitte ich darum den Ton der mir/uns hier entgegengebracht wird zu hinterfragen.

Das gebuhrt schon allein der Respekt, wir versuchen hier nach besten Wissen und Gewissen zu helfen.

Ebenso bitte ich auf die Riickfragen einzugehen oder eine Riickmeldung zu geben, wann das geschieht oder obsolet ist, anstatt neue Baustellen
(Stichwort Toolboxen) aufzumachen.

Das darfst du gerne so weitergeben und ich appeliere an unsere partnerschaftliche Zusammenarbeit.

Passt das nun mit der Fehlermeldung/Umsetzung oder nicht ?

Desweiteren ist noch folgender Punkt offen:
Anja Winkler wrote:

die Dependency Resolution im Configurationseditor ist zwar gut und auch schon besser geworden, 16st aber nicht alle Probleme, z.B.
werden die Run Level nicht berlicksichtigt.
Also selbst wenn das benutzt wurde, kann es zu Fehlern kommen.

Florian Roth wrote:

Das stimmt nicht, was meinst du damit ?

In jedem Service wird ein Default Runlevel definiert, das gibt der Entwickler vor und so landet es auch in der Plugin Description.
Siehe https://support.digitalwerk.net/adtf/v3/quides/sdk_generate_plugin_description.html

Wer das andert, bricht den Vertrag und muss sich dessen bewusst sein. Oder verstehe ich dich falsch ?

#9 - 2020-03-04 13:04 - hidden

Hallo Florian,

also vielen Dank fur deine Antwort. Es tut mir leid das auf Grund meiner Auslastung ich nicht alle Kommunikation Gberarbeitet habe oder sie auch
durcheinander geraten ist. Naturlich arbeiten wir hier partnerschaftlich zusammen, das steht hoffentlich auBer Frage. Ich werde die Anfragen wieder
gewissenhafter formulieren.

Martins Vorschlage passen soweit fir uns, du warst schneller mit deiner Antwort als ich die Riickmeldung hatte.

2024-04-25 5/6


https://support.digitalwerk.net/projects/download-center/wiki/KnownProblems#ADTF-Display-Toolbox-Known-Problems
https://support.digitalwerk.net/adtf/v3/guides/sdk_generate_plugin_description.html

Zu dem weiteren offenen Punkt. Ich denke das ist hier ein Missverstandnis das aus der Geschichte mit den Toolboxen resultierte und sich nun ja
aufgeldst hat, bzw. auf Grund von Martins und deiner weitern Antwort geldst hat.

Vielen Dank fur deine/eure Hilfe,

Anja

#10 - 2020-03-04 13:35 - hidden

- Project changed from 7 to Public Support

- Subject changed from EBPRODUCTSUPPORT-6326 [EB Germany]informationen (ber _runtime->GetObject()-Aufrufe sollten nachvollziehbar sein
to Improve IRuntime::GetObject error messages

- Description updated
- Status changed from Customer Feedback Required to To Be Closed
- Private changed from Yes to No

Hallo Anja,

Natdrlich arbeiten wir hier partnerschaftlich zusammen, das steht hoffentlich auBer Frage.

Auf jeden Fall

Martins Vorschlage passen soweit fir uns, du warst schneller mit deiner Antwort als ich die Riickmeldung hatte.
Zu dem weiteren offenen Punkt. Ich denke das ist hier ein Missverstandnis das aus der Geschichte mit den Toolboxen resultierte und sich nun ja
aufgeldst hat, bzw. auf Grund von Martins und deiner weitern Antwort geldst hat.

Gut, dann schlieBe ich das Ticket damit ab

#12 - 2020-07-07 12:49 - hidden
- Status changed from To Be Closed to Closed
